---
title: Delayed File Upload
product: Form Library
description: Learn how to effectively implement delayed file upload methods to optimize storage space and enhance user experience. Follow the step-by-step instructions for JavaScript to handle file uploads, downloads, and storage within various event handlers.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/delayed-file-upload/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Delayed File Upload (Vanilla JS)

Delayed file upload is a technique that enables you to postpone file upload until a certain moment. This technique helps save storage space on your server: if a user selects a file and then changes it to another, the first file won't be uploaded. This demo shows how to upload files when a survey is completed. Until that moment, files are stored in a variable as base64-encoded strings.

To implement delayed file upload, program different functionalities within the following event handlers:

- [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles)\
Add files to a variable that acts as a temporary file storage and load file previews.

- [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles)\
Remove all or individual files from the temporary file storage.

- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Upload files to a server and save metadata about them as the question value.

For more information, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function displaySurveyResults(result, data) {
    const text = JSON.stringify(data || result.data, null, 3);
    ["content-result-json-code", "surveyResult"].forEach(id => {
        const el = document.getElementById(id);
        if (el) el.textContent = text;
    });
}
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
const tempFileStorage = {}; // Temporary storage for uploaded files

function getStorageKey({ name, parent }) {
    let storageKey = name;
    // Check if the file upload is inside a dynamic panel and adjust the storage key accordingly
    if (parent && parent.parentQuestion && parent.parentQuestion.getType() === "paneldynamic") {
        const dynPanel = parent.parentQuestion;
        const panel = parent;
        const i = dynPanel.visiblePanels.indexOf(panel);
        storageKey = dynPanel.name + "_" + i + "_" + name;
    }
    return storageKey;
}

function getQuestionByStorageKey(survey, storageKey) {
    let q = survey.getQuestionByName(storageKey);
    if (!q) {
        // Parse storageKey to determine if it belongs to a dynamic panel
        const keyParts = storageKey.split("_");
        const dynPanelName = keyParts[0];

        const dynPanel = survey.getQuestionByName(dynPanelName);
        if (dynPanel && dynPanel.getType() === "paneldynamic") {
            const i = parseInt(keyParts[1], 10);
            const qName = keyParts.slice(2).join("_"); // Handle cases when the question name contains underscores
            q = dynPanel.panels[i] && dynPanel.panels[i].getQuestionByName(qName);
        }
    }
    return q;
}

survey.onUploadFiles.add((_, options) => {
    const key = getStorageKey(options.question);
    // Store files in a temporary storage
    if (tempFileStorage[key] !== undefined) {
        tempFileStorage[key] = tempFileStorage[key].concat(options.files);
    } else {
        tempFileStorage[key] = options.files;
    }

    // Generate file previews
    const content = [];
    options.files.forEach((file) => {
        const fileReader = new FileReader();
        fileReader.onload = () => {
            content.push({
                name: file.name,
                type: file.type,
                content: fileReader.result,
                file: file,
            });
            if (content.length === options.files.length) {
                // Return a file preview
                options.callback(
                    content.map((fileContent) => ({
                        file: fileContent.file,
                        content: fileContent.content,
                    }))
                );
            }
        };
        fileReader.readAsDataURL(file);
    });
});

// Handles file removal
survey.onClearFiles.add((_, options) => {
    const key = getStorageKey(options.question);

    // Clear all files if "Clear All" is clicked
    if (options.fileName === null) {
        tempFileStorage[key] = [];
        options.callback("success");
        return;
    }

    // Remove a specific file
    const tempFiles = tempFileStorage[key];
    if (tempFiles && tempFiles.length > 0) {
        const fileInfoToRemove = tempFiles.find(
            (file) => file.name === options.fileName
        );
        if (fileInfoToRemove) {
            const index = tempFiles.indexOf(fileInfoToRemove);
            tempFiles.splice(index, 1);
        }
    }
    options.callback("success");
});

// Handles file uploads when the survey is completed
survey.onComplete.add((result) => {
    displaySurveyResults(result, { data: "Please wait for files to upload." });
    const storageKeys = Object.keys(tempFileStorage);

    if (storageKeys.length === 0) {
        displaySurveyResults(result);
        return;
    }
    // Process each stored file set for upload
    const uploadPromises = storageKeys.map((key) => {
        const filesToUpload = tempFileStorage[key];
        const formData = new FormData();
        filesToUpload.forEach((file) => {
            formData.append(file.name, file);
        });

        return fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
            method: "POST",
            body: formData,
        })
            .then((response) => response.json())
            .then((data) => {
                // Assign the uploaded file metadata to the corresponding question
                const q = getQuestionByStorageKey(survey, key);
                if (q) {
                    q.value = filesToUpload.map((file) => ({
                        file: file,
                        type: file.type,
                        content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                    }));
                }
            })
            .catch((error) => {
                console.error("Error:", error);
            });
    });

    // Wait for all uploads to complete before displaying survey results
    Promise.all(uploadPromises).then(() => {
        displaySurveyResults(result);
    });
});

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "allowMultiple": true,
      "maxSize": 102400
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/delayed-file-upload/angular.md)
- [React](https://surveyjs.io/form-library/examples/delayed-file-upload/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/delayed-file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/delayed-file-upload/jquery.md)


---
title: Delayed File Upload
product: Form Library
description: Learn how to effectively implement delayed file upload methods to optimize storage space and enhance user experience. Follow the step-by-step instructions for JavaScript to handle file uploads, downloads, and storage within various event handlers.
framework: React
source: https://surveyjs.io/form-library/examples/delayed-file-upload/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Delayed File Upload (React)

Delayed file upload is a technique that enables you to postpone file upload until a certain moment. This technique helps save storage space on your server: if a user selects a file and then changes it to another, the first file won't be uploaded. This demo shows how to upload files when a survey is completed. Until that moment, files are stored in a variable as base64-encoded strings.

To implement delayed file upload, program different functionalities within the following event handlers:

- [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles)\
Add files to a variable that acts as a temporary file storage and load file previews.

- [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles)\
Remove all or individual files from the temporary file storage.

- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Upload files to a server and save metadata about them as the question value.

For more information, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function displaySurveyResults(result, data) {
    const text = JSON.stringify(data || result.data, null, 3);
    ["content-result-json-code", "surveyResult"].forEach(id => {
        const el = document.getElementById(id);
        if (el) el.textContent = text;
    });
}
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    const tempFileStorage = {}; // Temporary storage for uploaded files
    
    function getStorageKey({ name, parent }) {
        let storageKey = name;
        // Check if the file upload is inside a dynamic panel and adjust the storage key accordingly
        if (parent && parent.parentQuestion && parent.parentQuestion.getType() === "paneldynamic") {
            const dynPanel = parent.parentQuestion;
            const panel = parent;
            const i = dynPanel.visiblePanels.indexOf(panel);
            storageKey = dynPanel.name + "_" + i + "_" + name;
        }
        return storageKey;
    }
    
    function getQuestionByStorageKey(survey, storageKey) {
        let q = survey.getQuestionByName(storageKey);
        if (!q) {
            // Parse storageKey to determine if it belongs to a dynamic panel
            const keyParts = storageKey.split("_");
            const dynPanelName = keyParts[0];
    
            const dynPanel = survey.getQuestionByName(dynPanelName);
            if (dynPanel && dynPanel.getType() === "paneldynamic") {
                const i = parseInt(keyParts[1], 10);
                const qName = keyParts.slice(2).join("_"); // Handle cases when the question name contains underscores
                q = dynPanel.panels[i] && dynPanel.panels[i].getQuestionByName(qName);
            }
        }
        return q;
    }
    
    survey.onUploadFiles.add((_, options) => {
        const key = getStorageKey(options.question);
        // Store files in a temporary storage
        if (tempFileStorage[key] !== undefined) {
            tempFileStorage[key] = tempFileStorage[key].concat(options.files);
        } else {
            tempFileStorage[key] = options.files;
        }
    
        // Generate file previews
        const content = [];
        options.files.forEach((file) => {
            const fileReader = new FileReader();
            fileReader.onload = () => {
                content.push({
                    name: file.name,
                    type: file.type,
                    content: fileReader.result,
                    file: file,
                });
                if (content.length === options.files.length) {
                    // Return a file preview
                    options.callback(
                        content.map((fileContent) => ({
                            file: fileContent.file,
                            content: fileContent.content,
                        }))
                    );
                }
            };
            fileReader.readAsDataURL(file);
        });
    });
    
    // Handles file removal
    survey.onClearFiles.add((_, options) => {
        const key = getStorageKey(options.question);
    
        // Clear all files if "Clear All" is clicked
        if (options.fileName === null) {
            tempFileStorage[key] = [];
            options.callback("success");
            return;
        }
    
        // Remove a specific file
        const tempFiles = tempFileStorage[key];
        if (tempFiles && tempFiles.length > 0) {
            const fileInfoToRemove = tempFiles.find(
                (file) => file.name === options.fileName
            );
            if (fileInfoToRemove) {
                const index = tempFiles.indexOf(fileInfoToRemove);
                tempFiles.splice(index, 1);
            }
        }
        options.callback("success");
    });
    
    // Handles file uploads when the survey is completed
    survey.onComplete.add((result) => {
        displaySurveyResults(result, { data: "Please wait for files to upload." });
        const storageKeys = Object.keys(tempFileStorage);
    
        if (storageKeys.length === 0) {
            displaySurveyResults(result);
            return;
        }
        // Process each stored file set for upload
        const uploadPromises = storageKeys.map((key) => {
            const filesToUpload = tempFileStorage[key];
            const formData = new FormData();
            filesToUpload.forEach((file) => {
                formData.append(file.name, file);
            });
    
            return fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
                method: "POST",
                body: formData,
            })
                .then((response) => response.json())
                .then((data) => {
                    // Assign the uploaded file metadata to the corresponding question
                    const q = getQuestionByStorageKey(survey, key);
                    if (q) {
                        q.value = filesToUpload.map((file) => ({
                            file: file,
                            type: file.type,
                            content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                        }));
                    }
                })
                .catch((error) => {
                    console.error("Error:", error);
                });
        });
    
        // Wait for all uploads to complete before displaying survey results
        Promise.all(uploadPromises).then(() => {
            displaySurveyResults(result);
        });
    });
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "allowMultiple": true,
      "maxSize": 102400
    }
  ]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/delayed-file-upload/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/delayed-file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/delayed-file-upload/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/delayed-file-upload/vanillajs.md)


---
title: Delayed File Upload
product: Form Library
description: Learn how to effectively implement delayed file upload methods to optimize storage space and enhance user experience. Follow the step-by-step instructions for JavaScript to handle file uploads, downloads, and storage within various event handlers.
framework: Angular
source: https://surveyjs.io/form-library/examples/delayed-file-upload/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Delayed File Upload (Angular)

Delayed file upload is a technique that enables you to postpone file upload until a certain moment. This technique helps save storage space on your server: if a user selects a file and then changes it to another, the first file won't be uploaded. This demo shows how to upload files when a survey is completed. Until that moment, files are stored in a variable as base64-encoded strings.

To implement delayed file upload, program different functionalities within the following event handlers:

- [`onUploadFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onUploadFiles)\
Add files to a variable that acts as a temporary file storage and load file previews.

- [`onClearFiles`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onClearFiles)\
Remove all or individual files from the temporary file storage.

- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Upload files to a server and save metadata about them as the question value.

For more information, view code listings for Angular, React, Vue, jQuery, or Vanilla JavaScript.

> In this demo, files are uploaded to SurveyJS servers from where they are then deleted after a predefined period of time. We strongly encourage you to use your own servers for file uploads when you use SurveyJS to collect sensitive respondent data in your application.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "elements": [
    {
      "type": "file",
      "title": "Please upload your files",
      "name": "files",
      "storeDataAsText": false,
      "allowMultiple": true,
      "maxSize": 102400
    }
  ]
};
```

### `src/app/components/survey.component.css`

```css
/* You can add your custom CSS here. */
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

function displaySurveyResults(result, data) {
    const text = JSON.stringify(data || result.data, null, 3);
    ["content-result-json-code", "surveyResult"].forEach(id => {
        const el = document.getElementById(id);
        if (el) el.textContent = text;
    });
}
@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        const tempFileStorage = {}; // Temporary storage for uploaded files
        
        function getStorageKey({ name, parent }) {
            let storageKey = name;
            // Check if the file upload is inside a dynamic panel and adjust the storage key accordingly
            if (parent && parent.parentQuestion && parent.parentQuestion.getType() === "paneldynamic") {
                const dynPanel = parent.parentQuestion;
                const panel = parent;
                const i = dynPanel.visiblePanels.indexOf(panel);
                storageKey = dynPanel.name + "_" + i + "_" + name;
            }
            return storageKey;
        }
        
        function getQuestionByStorageKey(survey, storageKey) {
            let q = survey.getQuestionByName(storageKey);
            if (!q) {
                // Parse storageKey to determine if it belongs to a dynamic panel
                const keyParts = storageKey.split("_");
                const dynPanelName = keyParts[0];
        
                const dynPanel = survey.getQuestionByName(dynPanelName);
                if (dynPanel && dynPanel.getType() === "paneldynamic") {
                    const i = parseInt(keyParts[1], 10);
                    const qName = keyParts.slice(2).join("_"); // Handle cases when the question name contains underscores
                    q = dynPanel.panels[i] && dynPanel.panels[i].getQuestionByName(qName);
                }
            }
            return q;
        }
        
        survey.onUploadFiles.add((_, options) => {
            const key = getStorageKey(options.question);
            // Store files in a temporary storage
            if (tempFileStorage[key] !== undefined) {
                tempFileStorage[key] = tempFileStorage[key].concat(options.files);
            } else {
                tempFileStorage[key] = options.files;
            }
        
            // Generate file previews
            const content = [];
            options.files.forEach((file) => {
                const fileReader = new FileReader();
                fileReader.onload = () => {
                    content.push({
                        name: file.name,
                        type: file.type,
                        content: fileReader.result,
                        file: file,
                    });
                    if (content.length === options.files.length) {
                        // Return a file preview
                        options.callback(
                            content.map((fileContent) => ({
                                file: fileContent.file,
                                content: fileContent.content,
                            }))
                        );
                    }
                };
                fileReader.readAsDataURL(file);
            });
        });
        
        // Handles file removal
        survey.onClearFiles.add((_, options) => {
            const key = getStorageKey(options.question);
        
            // Clear all files if "Clear All" is clicked
            if (options.fileName === null) {
                tempFileStorage[key] = [];
                options.callback("success");
                return;
            }
        
            // Remove a specific file
            const tempFiles = tempFileStorage[key];
            if (tempFiles && tempFiles.length > 0) {
                const fileInfoToRemove = tempFiles.find(
                    (file) => file.name === options.fileName
                );
                if (fileInfoToRemove) {
                    const index = tempFiles.indexOf(fileInfoToRemove);
                    tempFiles.splice(index, 1);
                }
            }
            options.callback("success");
        });
        
        // Handles file uploads when the survey is completed
        survey.onComplete.add((result) => {
            displaySurveyResults(result, { data: "Please wait for files to upload." });
            const storageKeys = Object.keys(tempFileStorage);
        
            if (storageKeys.length === 0) {
                displaySurveyResults(result);
                return;
            }
            // Process each stored file set for upload
            const uploadPromises = storageKeys.map((key) => {
                const filesToUpload = tempFileStorage[key];
                const formData = new FormData();
                filesToUpload.forEach((file) => {
                    formData.append(file.name, file);
                });
        
                return fetch("https://api.surveyjs.io/private/Surveys/uploadTempFiles", {
                    method: "POST",
                    body: formData,
                })
                    .then((response) => response.json())
                    .then((data) => {
                        // Assign the uploaded file metadata to the corresponding question
                        const q = getQuestionByStorageKey(survey, key);
                        if (q) {
                            q.value = filesToUpload.map((file) => ({
                                file: file,
                                type: file.type,
                                content: "https://api.surveyjs.io/private/Surveys/getTempFile?name=" + data[file.name]
                            }));
                        }
                    })
                    .catch((error) => {
                        console.error("Error:", error);
                    });
            });
        
            // Wait for all uploads to complete before displaying survey results
            Promise.all(uploadPromises).then(() => {
                displaySurveyResults(result);
            });
        });
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add your custom CSS here. */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/delayed-file-upload/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/delayed-file-upload/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/delayed-file-upload/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/delayed-file-upload/vanillajs.md)
